/*
 * Copyright (C) 2021 Anton Romanov - All Rights Reserved
 * You may use, distribute and modify this code, please write to: romanov73@gmail.com.
 */

package ru.ulstu.extractor.heuristic.controller;

import org.eclipse.jgit.api.errors.GitAPIException;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.ulstu.extractor.heuristic.model.BusinessLogicUnit;
import ru.ulstu.extractor.heuristic.model.EntityUnit;
import ru.ulstu.extractor.heuristic.model.ResourceUnit;
import ru.ulstu.extractor.service.GitRepositoryService;

import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("StructuralUnitController")
public class StructuralUnitController {
    private final GitRepositoryService gitRepositoryService;

    public StructuralUnitController(GitRepositoryService gitRepositoryService) {
        this.gitRepositoryService = gitRepositoryService;
    }

    @GetMapping("get-entities")
    public List<EntityUnit> getEntities(String repositoryUrl, String branchName) throws IOException, GitAPIException {
        return gitRepositoryService.getEntities(repositoryUrl, branchName);
    }

    @GetMapping("get-business-logic")
    public List<BusinessLogicUnit> getBusinessLogic(String repositoryUrl, String branchName) throws IOException, GitAPIException {
        return gitRepositoryService.getBusinessLogic(repositoryUrl, branchName);
    }

    @GetMapping("get-resources")
    public List<ResourceUnit> getResource(String repositoryUrl, String branchName) throws IOException, GitAPIException {
        return gitRepositoryService.getResource(repositoryUrl, branchName);
    }
}
